<?php
// by Mike O. (mides), coolcms.org
require_once '../includes/sys.php';
require_once '../includes/auth_a.php';
require_once '../includes/header.php';

if (!access(3)) {
    redirect(HTTPHOME);
}

switch ($act) {
	default:
/*		$current_ext = 'mp3';
		$allowed_ext=explode('|', $config['allowed_ext']); 
		if(!in_array($current_ext, $allowed_ext)){ 
			echo 'error!';
		}
*/	
		echo '<div class="title"><a href="./">АДМ</a>&raquo; Внутренние страницы</div><div class="body">';
		note();
		
		$arrfiles = array();
        $globfiles = glob('../local/main/*.tpl');
        foreach ($globfiles as $filename) {
            $arrfiles[] = basename($filename);
        } 

        $total = count($arrfiles);
		if ($total > 0) {
			
			$pages = ceil($total / $config['onpage']);
			if ($page > $pages or $page == 0) {
				$page = 1;
			}
			$begin = ($page - 1) * $config['onpage'];
			
            if ($total < $begin + $config['onpage']) {
                $end = $total;
            } else {
                $end = $begin + $config['onpage'];
            } 
						
			for ($i = $begin; $i < $end; $i++) {
				$size = size(filesize('../local/main/'.$arrfiles[$i]));
				$tplname = str_replace('.tpl', '', $arrfiles[$i]);
				$edited = ccdate(filemtime('../local/main/'.$arrfiles[$i]), 0);
								
				echo '<a href="../index.php?act='.$tplname.'">'.$tplname.'</a> ('.$size.') <a href="?act=edit&amp;tpl='.$arrfiles[$i].'">ред</a>';
				if ($arrfiles[$i] !== 'index.tpl') {
					echo ', <a href="?act=del&amp;tpl='.$arrfiles[$i].'">del</a>';
				}
				echo '<br />Изменен: '.$edited.'<hr>';
			}
			
		}
		navig($page, '?', $pages);
		
		echo '<br /><a href="?act=create">Создать страницу</a><br /><a href="./">В админку</a>
		</div>';
	break;
	
	case 'create':
		if ($ok) {
			if (!empty($_POST['name']) and preg_match('|^[a-z0-9\-]+$|i', $_POST['name'])) {
				$filename = check($_POST['name']).'.tpl';
				if (!file_exists('../local/main/'.$filename)) {
					$create = fopen('../local/main/'.$filename, 'a+');
					if ($create == TRUE) {
						$_SESSION['note'] = 'Страница создана';
						redirect('?act=edit&tpl='.$filename);
					} else {
						$_SESSION['note'] = 'Ошибка. Возможно неверные CHMOD на папку /local/main/';
						redirect('?');
					}
				} else {
					$_SESSION['note'] = 'Страница с таким названием уже есть';
					redirect('?act=create');
				}
			} else {
				$_SESSION['note'] = 'Неверное название';
				redirect('?act=create');
			}
		} else {
			tp('<a href="?">Внутр. страницы</a>&raquo; Создать');
			echo '<div class="body">';
			note();
			echo '<form name="form" action="?act=create&amp;ok=1" method="post" name="form">
			Название(a-z, 0-9):<br /><input name="name" type="text" maxlength="25" /><br />
			<input name="submit" type="submit" value="Ok" />
			</form>';
			nav('?');
		}
	break;
	
	case 'edit':
		$tpl = check($_GET['tpl']);
		$file = '../local/main/'.$tpl;
		if (file_exists($file)) {
			if ($ok) {
				$fp = fopen($file, 'a+');
				ftruncate($fp, 0);
				$text = $_POST['text'];
				fputs($fp, $text);
				$_SESSION['note'] = 'Сохранено';
				redirect('?act=edit&tpl='.$tpl);
			} else {
				$tplname = str_replace('.tpl', '', $tpl);
				tp('<a href="?">Внутр. страницы</a>&raquo; Ред-е <a href="../index.php?act='.$tplname.'">'.$tplname.'</a>');
				echo '<div class="body">';
				note();
				echo '<form name="form" action="?act=edit&amp;tpl='.$tpl.'&amp;ok=1" method="post" name="form">
				<textarea name="text" cols="" rows="8">'.file_get_contents($file).'</textarea>
				<input name="submit" type="submit" value="Ok" />
				</form>';
				nav('?');
			}
		} else {
			redirect('?');
		}
	break;
	
	case 'del':
		$tpl = check($_GET['tpl']);
		if (file_exists('../local/main/'.$tpl)) {
			if ($ok) {
				$deletion = unlink('../local/main/'.$tpl);
				if ($deletion == TRUE) {
					$_SESSION['note'] = 'Страница удалена';
				} else {
					$_SESSION['note'] = 'Ошибка. Удалите вручную через FTP';
				}
				redirect('?');
			} else {
				tp('Подтвердите, пожалуйста');
				echo '<div class="body">';
				echo 'Вы действительно хотите удалить страницу '.$tpl.'?<br />
				<form name="form" action="?act=del&tpl='.$tpl.'&amp;ok=1" method="post" name="form">
				<input name="submit" type="submit" value="Ok" />
				</form>';
				nav('?');
			}
		} else {
			redirect('?');
		}
	break;
	
	
	
	
	
	
}

require_once '../includes/tail.php';
?>